#include "simulus.h"

int calstart(commands *commlist, int *count, float as, float ar, 
             float bs, float br, int numnodes) {
  int i, j, k;
  float *timeval;
  int curnode;
  int *curcomm;
  int *finished; 
  int done;
  int done2;
  int remotecomm;
  float tmptime;
  int tmpdiff;

  timeval = (float*)malloc(numnodes*sizeof(float));
  curcomm = (int*)malloc(numnodes*sizeof(int));
  finished = (int*)malloc(numnodes*sizeof(int));

  for(i=0;i<numnodes;i++) {
    timeval[i] = 0;
    curcomm[i] = 0;
    finished[i] = FALSE;
  }

  for(i=0;i<numnodes;i++) {
    tmptime = 0;
    for(j=0;j<count[i];j++) {
      commlist[i*MAXCOMM + j].done = FALSE;
      commlist[i*MAXCOMM + j].start = tmptime;
      if (commlist[i*MAXCOMM + j].command == SEND) {
        tmptime = tmptime + (as + bs * (commlist[i*MAXCOMM + j].length));    
      }
      if (commlist[i*MAXCOMM + j].command == RECV) {
        tmptime = tmptime + (ar + br * (commlist[i*MAXCOMM + j].length));
      }
      commlist[i*MAXCOMM + j].end = tmptime;
    }
  }       
  
  j=0;
  done = FALSE;
  while(!done) {
    for (i=0;i<numnodes;i++) {
      if (finished[i] == FALSE) {
        if (commlist[i*MAXCOMM + j].command == END) {
          if (j != (count[i]-1)) {
            pt(1);
            goto error;
          }
          finished[i] = TRUE;
          done = TRUE;
          for (k=0;k<numnodes;k++) {
            if (finished[k] == FALSE) done = FALSE;
          }
        }
        if (commlist[i*MAXCOMM + j].command == SEND) {
          curnode = commlist[i*MAXCOMM + j].node;
          done2 = FALSE;
          k=0;
          while (!done2) {
            if ((commlist[curnode*MAXCOMM + k].command == RECV) &&
                (commlist[curnode*MAXCOMM + k].node == i) &&
                (commlist[curnode*MAXCOMM + k].done == FALSE)) {
              remotecomm = k;
              commlist[curnode*MAXCOMM + k].done = TRUE;
              done2 = TRUE;
            } else {
              k++;
              if (k > count[curnode]) goto error;
            }
          }
          if ((commlist[i*MAXCOMM + j].end) >  
              (commlist[curnode*MAXCOMM + remotecomm].start)) {
            //shift recv down
            commlist[curnode*MAXCOMM + remotecomm].start = 
              commlist[i*MAXCOMM + j].end;
            commlist[curnode*MAXCOMM + remotecomm].end =
              commlist[curnode*MAXCOMM + remotecomm].start + 
              (ar + br * commlist[curnode*MAXCOMM + remotecomm].length);
            for (k=(remotecomm + 1);k<count[curnode];k++) {
              // shift the rest down
              if (commlist[curnode*MAXCOMM + k].start < 
                  commlist[curnode*MAXCOMM + (k-1)].end) {
                tmpdiff = commlist[curnode*MAXCOMM + (k-1)].end -
                  commlist[curnode*MAXCOMM + k].start;
                commlist[curnode*MAXCOMM + k].start = 
                  commlist[curnode*MAXCOMM + k].start + tmpdiff;
                commlist[curnode*MAXCOMM + k].end = 
                  commlist[curnode*MAXCOMM + k].end + tmpdiff;
              }
            }
          } 
          if ((commlist[i*MAXCOMM + j].end) <  
              (commlist[curnode*MAXCOMM + remotecomm].start)) {
            //shift send down
            commlist[i*MAXCOMM + j].end = 
              commlist[curnode*MAXCOMM + remotecomm].start;            
            commlist[i*MAXCOMM + j].start =
              commlist[i*MAXCOMM + j].end - 
              (as + bs * commlist[i*MAXCOMM + j].length);
            for (k=(j + 1);k<count[i];k++) {
              // shift the rest down
              if (commlist[i*MAXCOMM + k].start < 
                  commlist[i*MAXCOMM + (k-1)].end) {
                tmpdiff = commlist[i*MAXCOMM + (k-1)].end -
                  commlist[i*MAXCOMM + k].start;
                commlist[i*MAXCOMM + k].start = 
                  commlist[i*MAXCOMM + k].start + tmpdiff;
                commlist[i*MAXCOMM + k].end = 
                  commlist[i*MAXCOMM + k].end + tmpdiff;
              }
            }
          }
        }
        
      }
    }
    j++;
  }

/*    for (i=0;i<numnodes;i++) { */
/*      printf("STUFF FOR NODE %d\n",i); */
/*      for (j=0;j<count[i];j++) { */
/*        printf("%d - receive?- %d from - %d length - %f\n start - %f end - %f\n",  */
/*               j, commlist[i*MAXCOMM + j].command,  */
/*               commlist[i*MAXCOMM + j].node, commlist[i*MAXCOMM + j].length,  */
/*               commlist[i*MAXCOMM + j].start, */
/*               commlist[i*MAXCOMM + j].end); */
/*      } */
/*    } */

  return 0;

 error:
  printf("There was an error!\n");
  return -1;
}








