#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>

#define TEMPLATE "template.fig"
#define NUMCOLOURS 28

#define BLACK 0
#define BLUE 1
#define GREEN 2
#define CYAN 3
#define RED 4
#define MAGENTA 5
#define YELLOW 6
#define WHITE 7

#define BLUE2 8 
#define GREEN2 12
#define CYAN2 15
#define RED2 18
#define MAGENTA2 21
#define BROWN2 24
#define PINK2 27

#define BLUE3 9
#define GREEN3 13
#define CYAN3 16
#define RED3 19
#define MAGENTA3 22
#define BROWN3 25
#define PINK3 28

#define BLUE4 10
#define GREEN4 14
#define CYAN4 17
#define RED4 20
#define MAGENTA4 23
#define BROWN4 26
#define PINK4 29

#define WIDTH 600



int drawfighead();
int drawbox(int, int, int, int);

int main() { 
  int node;
  int start;
  int end;
  int colour;

  node = 0;
  start = 0;
  end = 300;
  colour = BLACK;

  drawfighead();
  drawbox(node, start, end, colour);

  node = 1;
  start = 300;
  end = 1200;
  colour = BLUE;
  drawbox(node, start, end, colour);

  return 0;
}

int drawfighead() {
  int infd;
  ssize_t insize;
  char *tmpbuf;

  infd = open(TEMPLATE, O_RDONLY);
  tmpbuf = (char*)malloc(sizeof(char));

  do {
    insize = read(infd, tmpbuf, sizeof(char));
    if (insize > 0) {
      printf("%c",*tmpbuf);
    }
  } while(insize > 0);

  close(infd);

  return 0;
}

int drawbox(int node, int start, int end, int colour) {
  int objectcode;
  int subtype;
  int linestyle;
  int thickness;
  int pencolour;
  int fillcolour;
  int depth;
  int penstyle;
  int areafill;
  float styleval;
  int joinstyle;
  int capstyle;
  int radius;
  int forwardarrow;
  int backwardarrow;
  int npoints;
  int ulx, urx, lrx, llx;
  int uly, ury, lry, lly;
  int xstart;
  int colours[NUMCOLOURS] = {BLACK, BLUE, GREEN, CYAN, RED, MAGENTA, YELLOW, 
                    BLUE2, GREEN2, CYAN2, RED2, MAGENTA2, BROWN2, PINK2,
                    BLUE3, GREEN3, CYAN3, RED3, MAGENTA3, BROWN3, PINK3,
                    BLUE4, GREEN4, CYAN4, RED4, MAGENTA4, BROWN4, PINK4};
  objectcode = 2;
  subtype = 2;
  linestyle = 0;
  thickness = 1;
  pencolour = colour;
  fillcolour = 7;
  depth = 50;
  penstyle = 0;
  areafill = -1;
  styleval = 0.0;
  joinstyle = 0;
  capstyle = 0;
  radius = 0;
  forwardarrow = 0;
  backwardarrow = 0;
  npoints = 5;

  printf("%d %d %d %d %d %d %d %d %d %f %d %d %d %d %d %d\n",
         objectcode, subtype, linestyle, thickness, pencolour, fillcolour,
         depth, penstyle, areafill, styleval, joinstyle, capstyle, radius,
         forwardarrow, backwardarrow, npoints);
  
  xstart = node*900;

  ulx = xstart;
  urx = xstart + WIDTH;
  llx = xstart;
  lrx = xstart + WIDTH;
  
  uly = start;
  lly = end;
  ury = start;
  lry = end;

  printf("%d %d %d %d %d %d %d %d %d %d\n",
         ulx, uly, urx, ury, lrx, lry, llx, lly, ulx, uly);
  
  return 0;
}










